#include <iostream>
#include <string>
#include <fstream>
#include <cstdlib>
using namespace std;

//same as description of the problem
const int MAX_ITEM_COUNT = 10;
class AbstractTSN {
	protected:
		string memberID;
		char gender;
		int age;
		int itemCount;
	public:
		AbstractTSN(string m, char g, int a, int i) {
			memberID=m;
			gender=g;
			age=a;
			itemCount=i;
		}
		int getItemCount() {
			return itemCount;
		}
		string getMem() {
			return memberID;
		}
		char getGen() {
			return gender;
		}
		
};

class FirstTSN : public AbstractTSN {
	private:
		bool* items;
	public:
		FirstTSN(string m, char g, int a, int it[], int itc) : AbstractTSN(m, g, a, itc) {
			items=new bool[MAX_ITEM_COUNT];
			for(int i=0; i<MAX_ITEM_COUNT; i++) {
				if(it[i]==1) {
					items[i]=true;
				} else {
					items[i]=false;
				}
			}
		}
		
		bool* getItem() {
			return items;
		}
		
};
class SecondTSN : public AbstractTSN {
	private:
		int* items;
	public:
		SecondTSN(string m, char g, int a, int it[], int itc) : AbstractTSN(m, g, a, itc) {
			items=new int[itc];
			for(int i=0; i<itc; i++) {
				items[i]=it[i];
			}
		}
		
		int* getItem() {
			return items;
		}
};


int main() {
	int fileNum;
	cin>>fileNum;
	
	//store all the transactions in two ways
	FirstTSN** ft=new FirstTSN*[1000*fileNum];
	int ftInd=0;
	SecondTSN** st=new SecondTSN*[1000*fileNum];
	int stInd=0;
	
	for(int i=0; i<fileNum; i++) {
		int type;
		string fileName;
		cin>>type>>fileName;
		
		ifstream fin(fileName.c_str());
		if(fin) {
			string line;
			while(getline(fin,line)) {
				//seperate the line by comma to get the information
				int dateComma=line.find(",", 0);
				string date=line.substr(0, dateComma);
				int memberComma=line.find(",", dateComma+1);
				string mem=line.substr(dateComma+1, memberComma-dateComma-1);
				int genderComma=line.find(",", memberComma+1);
				string gender=line.substr(memberComma+1, genderComma-memberComma-1);
				int ageComma=line.find(",", genderComma+1);
				int age=atoi(line.substr(genderComma+1, ageComma-genderComma-1).c_str());
				
				if(type==1) {
					int itemIndex=line.find(",", ageComma+1)-1;
					int item[MAX_ITEM_COUNT];
					int itc=0;
					//The 1s or 0s which indicate whether buy the items or not are seperate by a comma.
					//So I can get the value by check every two digit.
					for(int j=0; j<MAX_ITEM_COUNT; j++) {
						item[j]=line[itemIndex+2*j]-'0';
						if(item[j]==1) {
							itc++;
						}
					}
					
					//store it
					ft[ftInd]=new FirstTSN(mem, gender[0], age, item, itc);
					ftInd++;
				} else {
					int item[MAX_ITEM_COUNT];
					int itemInd=0;
					for(int j=0; j<MAX_ITEM_COUNT; j++) {
						item[j]=-1;
					}
					int thisComma=ageComma;
					//If the transactions are type 2, I don't know the number of items he or she bought.
					//So I should use while to get all the items he or she bought.
					while(line.find(",", thisComma+1)!=string::npos) {
						int nextComma=line.find(",", thisComma+1);
						int buy=atoi(line.substr(thisComma+1, nextComma-thisComma-1).c_str());
						item[itemInd]=buy;
						itemInd++;
						
						thisComma=nextComma;
					}
					int buy=atoi(line.substr(thisComma+1, line.length()-thisComma).c_str());
					item[itemInd]=buy;
					itemInd++;
					
					st[stInd]=new SecondTSN(mem, gender[0], age, item, itemInd);
					stInd++;
					
					
				}
				
			}
			fin.close();
		}
	}
	//store the number of items bought by 5 categories
	int male[MAX_ITEM_COUNT], female[MAX_ITEM_COUNT], member[MAX_ITEM_COUNT], nonmem[MAX_ITEM_COUNT], most[MAX_ITEM_COUNT];
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		male[i]=0;
		female[i]=0;
		member[i]=0;
		nonmem[i]=0;
		most[i]=0;
	}
	//type1
	//count for the number of item bought by the people of the categories
	for(int i=0; i<ftInd; i++) {
		bool* item=ft[i]->getItem();
		string mem=ft[i]->getMem();
		char gender=ft[i]->getGen();
		for(int j=0; j<MAX_ITEM_COUNT; j++) {
			if(item[j]) {
				if(mem.length()!=0) {
					member[j]++;
				} else {
					nonmem[j]++;
				}
				
				if(gender=='M') {
					male[j]++;
				} else if (gender=='F') {
					female[j]++;
				}
				
				most[j]++;
			}
		}
	}
	//type2
	for(int i=0; i<stInd; i++) {
		int itemInd=st[i]->getItemCount();
		int* item=st[i]->getItem();
		string mem=st[i]->getMem();
		char gender=st[i]->getGen();
		for(int j=0; j<itemInd; j++) {
			if(mem.length()!=0) {
				member[item[j]-1]++;
			} else {
				nonmem[item[j]-1]++;
			}
			
			if(gender=='M') {
				male[item[j]-1]++;
			} else if (gender=='F') {
				female[item[j]-1]++;
			}
			
			most[item[j]-1]++;
		}
	}
	//count the max
	int maleMax=0, femaleMax=0, memberMax=0, nonmemMax=0, max=0;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(male[i]>maleMax)
			maleMax=male[i];
		if(female[i]>femaleMax)
			femaleMax=female[i];
		if(member[i]>memberMax)
			memberMax=member[i];
		if(nonmem[i]>nonmemMax)
			nonmemMax=nonmem[i];
		if(most[i]>max)
			max=most[i];
	}
	
	//output
	bool firstFlag=true;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(male[i]==maleMax) {
			if(firstFlag) {
				cout<<i+1;
				firstFlag=false;
			}
			else
				cout<<" "<<i+1;
		}	
	}
	cout<<endl;
	firstFlag=true;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(female[i]==femaleMax) {
			if(firstFlag) {
				cout<<i+1;
				firstFlag=false;
			}
			else
				cout<<" "<<i+1;
		}	
	}
	cout<<endl;
	firstFlag=true;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(member[i]==memberMax) {
			if(firstFlag) {
				cout<<i+1;
				firstFlag=false;
			}
			else
				cout<<" "<<i+1;
		}	
	}
	cout<<endl;
	firstFlag=true;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(nonmem[i]==nonmemMax) {
			if(firstFlag) {
				cout<<i+1;
				firstFlag=false;
			}
			else
				cout<<" "<<i+1;
		}	
	}
	cout<<endl;
	firstFlag=true;
	for(int i=0; i<MAX_ITEM_COUNT; i++) {
		if(most[i]==max) {
			if(firstFlag) {
				cout<<i+1;
				firstFlag=false;
			}
			else
				cout<<" "<<i+1;
		}	
	}
	cout<<endl;
	return 0;
}
