#include <iostream>
#include <string>
#include <fstream>
#include <cstdlib>
#include <cmath>
using namespace std;

const int MAX_ITEM_COUNT = 10;
class AbstractTSN {
	protected:
		string memberID;
		char gender;
		int age;
		int itemCount;
	public:
		AbstractTSN(string m, char g, int a, int i) {
			memberID=m;
			gender=g;
			age=a;
			itemCount=i;
		}
		int getItemCount() {
			return itemCount;
		}
		string getMem() {
			return memberID;
		}
		char getGen() {
			return gender;
		}
		
};

class FirstTSN : public AbstractTSN {
	private:
		bool* items;
	public:
		FirstTSN(string m, char g, int a, int it[], int itc) : AbstractTSN(m, g, a, itc) {
			items=new bool[MAX_ITEM_COUNT];
			for(int i=0; i<MAX_ITEM_COUNT; i++) {
				if(it[i]==1) {
					items[i]=true;
				} else {
					items[i]=false;
				}
			}
		}
		
		bool* getItem() {
			return items;
		}
		
};
class SecondTSN : public AbstractTSN {
	private:
		int* items;
	public:
		SecondTSN(string m, char g, int a, int it[], int itc) : AbstractTSN(m, g, a, itc) {
			items=new int[itc];
			for(int i=0; i<itc; i++) {
				items[i]=it[i];
			}
		}
		
		int* getItem() {
			return items;
		}
};


int main() {
	int fileNum;
	cin>>fileNum;
	
	FirstTSN** ft=new FirstTSN*[1000*fileNum];
	int ftInd=0;
	SecondTSN** st=new SecondTSN*[1000*fileNum];
	int stInd=0;
	
	//Here is the different part.
	//I should store the file name and the type, which allowed me to read m and n first. This can save a lot of memories.
	int* type=new int[fileNum];
	string* fileName=new string[fileNum];
	for(int i=0; i<fileNum; i++) {
		cin>>type[i]>>fileName[i];
	}
	int m, n;
	cin>>m>>n;
	//I can store just m and mn count instead of all the items.
	int nCount=0, mnCount=0;
	for(int i=0; i<fileNum; i++) {
		
		ifstream fin(fileName[i].c_str());
		if(fin) {
			string line;
			while(getline(fin,line)) {
				int dateComma=line.find(",", 0);
				string date=line.substr(0, dateComma);
				int memberComma=line.find(",", dateComma+1);
				string mem=line.substr(dateComma+1, memberComma-dateComma-1);
				int genderComma=line.find(",", memberComma+1);
				string gender=line.substr(memberComma+1, genderComma-memberComma-1);
				int ageComma=line.find(",", genderComma+1);
				int age=atoi(line.substr(genderComma+1, ageComma-genderComma-1).c_str());

				if(type[i]==1) {
					int itemIndex=line.find(",", ageComma+1)-1;
					int item[MAX_ITEM_COUNT];
					int itc=0;
					for(int j=0; j<MAX_ITEM_COUNT; j++) {
						item[j]=line[itemIndex+2*j]-'0';
						if(item[j]==1) {
							itc++;
						}
					}
					
					ft[ftInd]=new FirstTSN(mem, gender[0], age, item, itc);
					ftInd++;
					
				} else {
					int item[MAX_ITEM_COUNT];
					int itemInd=0;
					for(int j=0; j<MAX_ITEM_COUNT; j++) {
						item[j]=-1;
					}
					int thisComma=ageComma;
					while(line.find(",", thisComma+1)!=string::npos) {
						int nextComma=line.find(",", thisComma+1);
						int buy=atoi(line.substr(thisComma+1, nextComma-thisComma-1).c_str());
						item[itemInd]=buy;
						itemInd++;
						
						thisComma=nextComma;
					}
					int buy=atoi(line.substr(thisComma+1, line.length()-thisComma).c_str());
					item[itemInd]=buy;
					itemInd++;
					
					st[stInd]=new SecondTSN(mem, gender[0], age, item, itemInd);
					stInd++;
					
				}
				
			}
			fin.close();
		}
	}
	for(int i=0; i<ftInd; i++) {
		bool* item=ft[i]->getItem();
		//If the customer bought n, then n count++.
		if(item[n-1]) {
			nCount++;
			//If the customer bought both m and n, then mn count++.
			if(item[m-1]) {
				mnCount++;
			}
		}
	}
	for(int i=0; i<stInd; i++) {
		int* item=st[i]->getItem();
		int itemCount=st[i]->getItemCount();
		//If the customer bought n, then n count++.
		bool nExist=false;
		bool mExist=false;
		for(int j=0; j<itemCount; j++) {
			if(item[j]==n) {
				nExist=true;
			}
			if(item[j]==m) {
				mExist=true;
			}
		}
		if(nExist) {
			nCount++;
			//If the customer bought both m and n, then mn count++.
			if(mExist) {
				mnCount++;
			}
		}
	}
	//The answer is just mnCount/nCount.
	float answer=round(mnCount*100.0/nCount);
	cout<<answer<<endl;
	return 0;
}
